local UrzUI = CreateFrame("Frame", "UrzUI", UIParent);
local UrzCan = CreateFrame("Frame", "UrzCan", UIParent);

local function Remove(name)
   if ( name ) then
      name:Hide();
      name:SetParent(UrzCan);
   end
end

local function Move(name, pos1, parent, pos2, x, y)
   name:ClearAllPoints();
   name:SetPoint(pos1, parent, pos2, x, y);
end

local function SetUI()
   UrzCan:Hide();
   for _, name in pairs({MainMenuBarPageNumber, ActionBarUpButton, ActionBarDownButton, MainMenuBarLeftEndCap, MainMenuBarRightEndCap, MainMenuXPBarTextureLeftCap, MainMenuXPBarTextureMid, MainMenuXPBarTextureRightCap, StanceBarLeft, StanceBarMiddle, StanceBarRight, SlidingActionBarTexture0, SlidingActionBarTexture1, PossessBackground1, PossessBackground2, MainMenuXPBarDiv1, MainMenuXPBarDiv2, MainMenuXPBarDiv3, MainMenuXPBarDiv4, MainMenuXPBarDiv5, MainMenuXPBarDiv6, MainMenuXPBarDiv7, MainMenuXPBarDiv8, MainMenuXPBarDiv9, MainMenuXPBarDiv10, MainMenuXPBarDiv11, MainMenuXPBarDiv12, MainMenuXPBarDiv13, MainMenuXPBarDiv14, MainMenuXPBarDiv15, MainMenuXPBarDiv16, MainMenuXPBarDiv17, MainMenuXPBarDiv18, MainMenuXPBarDiv19, MainMenuBarTexture0, MainMenuBarTexture1, MainMenuBarTexture2, MainMenuBarTexture3, ReputationXPBarTexture0, ReputationXPBarTexture1, ReputationXPBarTexture2, ReputationXPBarTexture3, ReputationWatchBarTexture0, ReputationWatchBarTexture1, ReputationWatchBarTexture2, ReputationWatchBarTexture3, MainMenuMaxLevelBar0, MainMenuMaxLevelBar1, MainMenuMaxLevelBar2, MainMenuMaxLevelBar3, MinimapZoomIn, MinimapZoomOut, MiniMapTracking, CombatLogQuickButtonFrame_Custom}) do
      Remove(name);
   end
   for _, name in pairs({StanceBarFrame, PossessBarFrame, PetActionBarFrame, MultiBarLeft, MultiBarRight, MultiBarBottomLeft, MultiBarBottomRight, MainMenuBar, MainMenuBarMaxLevelBar}) do
      name:SetFrameStrata("MEDIUM");
      name:EnableMouse(false);
   end
   for _, text in pairs({"ActionButton", "MultiBarBottomLeftButton", "MultiBarBottomRightButton", "MultiBarLeftButton", "MultiBarRightButton", "StanceButton", "PossessButton", "PetActionButton"}) do
      for i = 1, 12 do
         local name = _G[text..i];
         if ( name ) then
            name:GetNormalTexture():SetPoint("TOPLEFT", name, "TOPLEFT", -12, 12);
            name:GetNormalTexture():SetPoint("BOTTOMRIGHT", name, "BOTTOMRIGHT", 13, -13);
            name:SetSize(36, 36);
            name:SetScale(1);
            Remove(_G[text..i.."FloatingBG"]);
            Remove(_G[text..i.."Name"]);
         end
      end
   end
   MainMenuBarVehicleLeaveButton:SetSize(36, 36);
   for _, name in pairs({MainMenuBarVehicleLeaveButton, StanceBarFrame, PossessBarFrame, PetActionBarFrame}) do
      name:SetScale(0.7);
   end
   MainMenuBar:SetWidth(512);
   Move(MultiBarBottomLeftButton1, "BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 6);
   Move(MultiBarBottomRightButton1, "BOTTOMLEFT", MultiBarBottomLeftButton1, "TOPLEFT", 0, 6);
   Move(StanceButton1, "BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
   Move(PossessButton1, "BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
   Move(PetActionButton10, "BOTTOMRIGHT", MultiBarBottomRightButton12, "TOPRIGHT", 0, 6);
   Move(PossessButton2, "LEFT", PossessButton1, "RIGHT", 6, 0);
   for i = 2, 10 do
      Move(_G["StanceButton"..i], "LEFT", _G["StanceButton"..i-1], "RIGHT", 6, 0);
      Move(_G["PetActionButton"..11-i], "RIGHT", _G["PetActionButton"..12-i], "LEFT", -6, 0);
   end
   hooksecurefunc("MainMenuBarVehicleLeaveButton_Update", function()
         if (( GetNumShapeshiftForms() < 1 ) and not IsPossessBarVisible() ) then
            Move(MainMenuBarVehicleLeaveButton, "BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
         end
   end);
   MainMenuBarVehicleLeaveButton_Update();
   local function setup()
      if ( MainMenuBar:IsShown() ) then
         Move(CharacterMicroButton, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -275, 1);
         Move(PVPMicroButton, "BOTTOMLEFT", GuildMicroButton, "BOTTOMRIGHT", -3, 0);
      end
   end
   setup();
   hooksecurefunc("MoveMicroButtons", setup);
   local function setup()
      MainMenuExpBar:SetSize(300, 13);
      ReputationWatchStatusBar:SetSize(300, 13);
      ReputationWatchBar:SetSize(300, 13);
      ReputationWatchStatusBarText:SetPoint("CENTER", ReputationWatchBarOverlayFrame, "CENTER", 0, 1);
      ReputationWatchBarOverlayFrame:SetFrameStrata("MEDIUM");
      local y = 40;
      Move(MainMenuExpBar, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
      if ( MainMenuExpBar:IsShown() ) then
         y = y+16;
      end
      Move(ReputationWatchBar, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
      if ( ReputationWatchBar:IsShown() ) then
         y = y+16;
      end
      Move(MainMenuBarBackpackButton, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
   end
   setup();
   hooksecurefunc("ReputationWatchBar_Update", setup);
   CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 1;
   CHAT_FRAME_TAB_NORMAL_MOUSEOVER_ALPHA = 0.5;
   CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0.5;
   DEFAULT_CHATFRAME_ALPHA = 0;
   CHAT_FRAME_FADE_OUT_TIME = 0;
   CHAT_FRAME_BUTTON_FRAME_MIN_ALPHA = 1;
   for i = 1, NUM_CHAT_WINDOWS do
      for _, text in pairs({"TabLeft", "TabMiddle", "TabRight", "TabSelectedLeft", "TabSelectedMiddle", "TabSelectedRight", "TabHighlightLeft", "TabHighlightMiddle", "TabHighlightRight", "ButtonFrameMinimizeButton", "ButtonFrameDownButton", "ButtonFrameUpButton", "ButtonFrameBackground", "ButtonFrameTopLeftTexture", "ButtonFrameBottomLeftTexture", "ButtonFrameTopRightTexture", "ButtonFrameBottomRightTexture", "ButtonFrameLeftTexture", "ButtonFrameRightTexture", "ButtonFrameBottomTexture", "ButtonFrameTopTexture"}) do
         Remove(_G["ChatFrame"..i..text]);
      end
      _G["ChatFrame"..i]:SetClampRectInsets(0, 0, 20, 0);
      _G["ChatFrame"..i.."Tab"]:SetScript("OnDoubleClick", nil);
      FCFTab_UpdateAlpha(_G["ChatFrame"..i]);
      if ( i ~= 1 ) then
         _G["ChatFrame"..i.."EditBox"]:SetAllPoints(ChatFrame1EditBox);
      end
   end
   FCFManager_RegisterDedicatedFrame(ChatFrame2, "PET_BATTLE_COMBAT_LOG");
   CombatLogQuickButtonFrame_Custom:SetHeight(0);
   for name in pairs(ChatTypeGroup) do
      SetChatColorNameByClass(name, true);
   end
   for i = 1, MAX_WOW_CHAT_CHANNELS do
      local name = "CHANNEL"..i;
      if ( name ) then
         SetChatColorNameByClass(name, true);
      end
   end
   Minimap:EnableMouseWheel(true);
   Minimap:SetScript("OnMouseWheel", function(self, delta)
         local zoom = Minimap:GetZoom();
         if ( delta > 0 and zoom < 5 ) then
            Minimap:SetZoom(zoom+1);
         elseif ( delta < 0 and zoom > 0 ) then
            Minimap:SetZoom(zoom-1);
         end
   end);
   Minimap:SetScript("OnMouseUp", function(self, button)
         if ( button == "LeftButton" ) then
            Minimap_OnClick(self);
         elseif ( button == "RightButton" ) then
            PlaySound("igMainMenuOptionCheckBoxOn");
            ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, "Minimap", -150, 130);
         end
   end);
   ChatFrameMenuButton:SetScript("OnClick", function(self, button)
         PlaySound("igChatEmoteButton");
         if ( not ChatMenu:IsShown() ) then
            ChatMenu:Show();
         else
            ChatMenu:Hide();
         end
   end);
   DigsiteCompleteToastFrame:SetFrameStrata("MEDIUM");
   PlayerFrame:UnregisterEvent("UNIT_COMBAT");
   PetFrame:UnregisterEvent("UNIT_COMBAT");
   for _, name in pairs({PlayerStatusTexture, PlayerAttackBackground, PlayerFrameFlash, PlayerStatusGlow, PlayerAttackGlow, PlayerRestGlow, PlayerHitIndicator, PetFrameFlash, PetAttackModeTexture, PetHitIndicator}) do
      Remove(name);
   end
   hooksecurefunc("PlayerFrame_UpdateStatus", function()
         if (( not UnitHasVehiclePlayerFrameUI("player") ) and ( UnitAffectingCombat("player") )) then
            PlayerAttackIcon:Show();
            PlayerRestIcon:Hide();
         end
   end);
end

function SetUrzNameplates()
   if ( UrzOptions[1]) then
      if ( not UrzNameplates ) then
         UrzNameplates = CreateFrame("Frame", "UrzNameplates", UIParent);
         UrzNameplates:SetScript("OnUpdate", function(self, elapsed)
               for i = 1, WorldFrame:GetNumChildren() do
                  local frame = select(i, WorldFrame:GetChildren());
                  if ( frame:GetName() and frame:GetName():match("NamePlate") ) then
                     local plate, name = frame:GetChildren();
                     local threat, bg, _, lvl = plate:GetRegions();
                     local font = name:GetRegions();
                     if ( bg:IsShown() ) then
                        bg:Hide();
                        font:SetFont("Fonts\\ARIALN.TTF", 12, nil);
                        font:SetShadowOffset(1, -1);
                        lvl:SetFont("Fonts\\ARIALN.TTF", 12, nil);
                        lvl:SetShadowOffset(1, -1);
                     end
                     if ( threat:IsShown() ) then
                        font:SetTextColor(1, 0.3, 0, 1);
                     else
                        font:SetTextColor(1, 1, 1, 1);
                     end
                     if ( UnitExists("target") and ( frame:GetAlpha() == 1 )) then
                        threat:SetVertexColor(1, 1, 1, 1);
                        threat:Show();
                     else
                        threat:Hide();
                     end
                     frame:SetAlpha(1);
                  end
               end
         end);
      end
      UrzNameplates:Show();
   elseif ( UrzNameplates ) then
      UrzNameplates:Hide();
   end
end

function SetUrzAutoChat()
   if ( UrzOptions[2] ) then
      local function setup()
         if ( UrzOptions[2] ) then
            if ( OverrideActionBar:IsShown() or PetBattleFrame:IsShown() ) then
               Move(ChatFrame1, "BOTTOMLEFT", UIParent, 34, 150);
            else
               Move(ChatFrame1, "BOTTOMLEFT", UIParent, 34, 34);
            end
            ChatFrame1:SetSize(GetScreenWidth()/2-292, 115);
            for i = 1, NUM_CHAT_WINDOWS do
               FCF_UpdateButtonSide(_G["ChatFrame"..i]);
            end
            FCF_SetLocked(ChatFrame1, true);
         end
      end
      setup();
      if ( not UrzChat ) then
         UrzChat = CreateFrame("Frame", "UrzChat", UIParent);
         UrzChat:SetScript("OnEvent", setup);
         UrzChat:RegisterEvent("DISPLAY_SIZE_CHANGED");
         UrzChat:RegisterEvent("UI_SCALE_CHANGED");
         for _, name in pairs({OverrideActionBar, PetBattleFrame}) do
            for _, event in pairs({"OnShow", "OnHide"}) do
               name:HookScript(event, setup);
            end
         end
      end
      UrzChat:Show();
   elseif ( UrzChat ) then
      UrzChat:Hide();
   end
end

function SetUrzStackedLog()
   if ( UrzOptions[3] ) then
      FCF_UnDockFrame(ChatFrame2);
      Move(ChatFrame2, "BOTTOMLEFT", ChatFrame1, "TOPLEFT", 0, 44);
      ChatFrame2:SetSize(ChatFrame1:GetWidth(), 65);
      FCF_SetTabPosition(ChatFrame2, 0);
      FCF_UpdateButtonSide(ChatFrame2);
      FCF_FadeOutChatFrame(ChatFrame2);
      FCF_SetLocked(ChatFrame2, true);
      FCF_DockUpdate();
      UrzHasSetStackedLog = true;
   elseif ( UrzHasSetStackedLog ) then
      FCF_DockFrame(ChatFrame2, 2, false);
   end
end

function SetUrzHideError()
   if ( UrzOptions[4] ) then
      UIErrorsFrame:Hide();
   else
      UIErrorsFrame:Show();
   end
end

function SetUrzGuildRepair()
   if ( not UrzRepair ) then
      UrzRepair = CreateFrame("Frame", "UrzRepair", UIParent);
      UrzRepair:RegisterEvent("MERCHANT_SHOW");
   end
   UrzRepair:SetScript("OnEvent", function(self, event, ...)
         for bag = 0, 4 do
            for slot = 0, GetContainerNumSlots(bag) do
               local link = GetContainerItemLink(bag, slot);
               if ( link and (select(3, GetItemInfo(link)) == 0) ) then
                  UseContainerItem(bag, slot);
               end
            end
         end
         RepairAllItems(UrzOptions[5]);
   end);
end

function SetUrzRightClick()
   if ( UrzOptions[6] ) then
      local time = 0;
      WorldFrame:SetScript("OnMouseUp", function(self, button)
            if ( UnitAffectingCombat("player") and ( button == "RightButton" ) and ( time < GetTime() )) then
               time = GetTime()+0.3;
               MouselookStop();
            end
      end);
   else
      WorldFrame:SetScript("OnMouseUp", nil);
   end
end

function SetUrzHealthPlayer()
   if ( not UrzHealthPlayer ) then
      UrzHealthPlayer = true;
      hooksecurefunc("TextStatusBar_UpdateTextString", function(textStatusBar)
            if ( UrzOptions[7] and ( textStatusBar == PlayerFrameHealthBar ) and not PlayerFrameHealthBar.showNumeric ) then
               if ( UnitIsDeadOrGhost("player") ) then
                  PlayerFrameHealthBarText:SetText(NORMAL_FONT_COLOR_CODE.."Dead"..FONT_COLOR_CODE_CLOSE);
               elseif ( UnitHasVehiclePlayerFrameUI("player") ) then
                  PlayerFrameHealthBarText:SetText(AbbreviateLargeNumbers((UnitHealth("vehicle") or 0)+(UnitGetTotalAbsorbs("vehicle") or 0)));
               else
                  PlayerFrameHealthBarText:SetText(AbbreviateLargeNumbers((UnitHealth("player") or 0)+(UnitGetTotalAbsorbs("player") or 0)));
               end
            end
      end);
      PlayerFrameHealthBar:RegisterUnitEvent("UNIT_ABSORB_AMOUNT_CHANGED", "player");
   end
   TextStatusBar_UpdateTextString(PlayerFrameHealthBar);
end

function SetUrzHealthTarget()
   if ( not UrzHealthTarget ) then
      UrzHealthTarget = true;
      hooksecurefunc("TextStatusBar_UpdateTextString", function(textStatusBar)
            if ( UrzOptions[8] and ( textStatusBar == TargetFrameHealthBar )) then
               if ( UnitIsDeadOrGhost("target") ) then
                  TargetFrameTextureFrameHealthBarText:SetText(NORMAL_FONT_COLOR_CODE.."Dead"..FONT_COLOR_CODE_CLOSE);
               else
                  local max = UnitHealthMax("target") or 0;
                  local health = UnitHealth("target") or 0;
                  if (( max > 0 ) and ( health > 0 )) then
                     TargetFrameTextureFrameHealthBarText:SetFormattedText("%i%%   %s", ceil(health/max*100), AbbreviateLargeNumbers(health));
                  end
               end
            end
      end);
   end
   TextStatusBar_UpdateTextString(TargetFrameHealthBar);
end

local function SetConfig()
   UrzUI.name = "UrzUI";
   InterfaceOptions_AddCategory(UrzUI);
   SlashCmdList["UrzSlash"] = function()
      InterfaceOptionsFrame:Show();
      InterfaceOptionsFrame_OpenToCategory("UrzUI");
   end;
   SLASH_UrzSlash1 = "/urz";
   local text1 = UrzUI:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
   local text2 = UrzUI:CreateFontString(nil, "ARTWORK", "QuestFont_Large");
   text1:SetPoint("TOPLEFT", 16, -16);
   text1:SetText("UrzUI Configuration");
   text2:SetJustifyH("RIGHT");
   text2:SetPoint("BOTTOMRIGHT", -16, 16);
   text2:SetText("To my beloved Madelene :) \n\n– Fredrik   ");
   if ( type(UrzOptions) ~= "table" ) then
      UrzOptions = {[1] = 1};
   end
   local ConfigSettings = {
      [1] = {Script = "SetUrzNameplates()", Text = "UrzNameplates."},
      [2] = {Script = "SetUrzAutoChat()", Text = "Auto-position chat frames."},
      [3] = {Script = "SetUrzStackedLog()", Text = "Stack combat log."},
      [4] = {Script = "SetUrzHideError()", Text = "Hide error messages."},
      [5] = {Script = "SetUrzGuildRepair()", Text = "Auto-guild-repair. (Uncheck to auto-repair with your own gold.)"},
      [6] = {Script = "SetUrzRightClick()", Text = "Disable right-click interaction in combat. (Right-double-click works instead.)"},
      [7] = {Script = "SetUrzHealthPlayer()", Text = "Display player health in numbers, including total absorbs."},
      [8] = {Script = "SetUrzHealthTarget()", Text = "Display target health in both percentage and numbers."},
   };
   local box = {};
   for i = 1, #ConfigSettings do
      box[i] = CreateFrame("CheckButton", "box"..i, UrzUI, "UICheckButtonTemplate");
      Move(box[i], "TOPLEFT", UrzUI, "TOPLEFT", 16, -i*25-15);
      box[i].Script = ConfigSettings[i]["Script"];
      box[i].Option = i;
      box[i]:SetChecked(UrzOptions[i]);
      _G[box[i]:GetName().."Text"]:SetText(ConfigSettings[i]["Text"]);
      box[i]:SetScript("OnClick", function(self, button, down)
            UrzOptions[self.Option] = self:GetChecked();
            RunScript(self.Script);
      end);
      RunScript(box[i].Script);
   end
   UrzUI:SetScript("OnShow", function(self)
         for i = 1, #ConfigSettings do
            box[i]:SetChecked(UrzOptions[i]);
         end
   end);
end

UrzUI:SetScript("OnEvent", function(self, event, ...)
      if ( not UnitAffectingCombat("player") ) then
         UrzUI:UnregisterAllEvents();
         SetUI();
         SetConfig();
      end
end);
UrzUI:RegisterEvent("PLAYER_ENTERING_WORLD");
UrzUI:RegisterEvent("PLAYER_REGEN_ENABLED");
